<?php
header("Access-Control-Allow-Origin: *");
header("Access-Control-Allow-Headers: *");

include_once __DIR__ . '/../../config/db-connection.php';
include_once __DIR__ . '/../../config/https_environment.php';
include_once __DIR__ . '/../../utils/utils.php';

$emails = [
    "hubnerbtech@gmail.com","albotton4@hotmail.com","laura.00282154@aluno.sesirs.com.br","troquatogiovana@gmail.com","micaelabb70@gmail.com","alinecampanaa@gmail.com","carvalhoclysna@gmail.com","melocarpediem38@gmail.com","cogumelos221@gmail.com","anabemfica4@gmail.com","2022321179@aluno.osorio.ifrs.edu.br","luysa-ebolacel@educar.rs.gov.br","carlos@uceff.edu.br","graziagri@yahoo.com.br","amandaquiv@gmail.com","haislalima@gmail.com","lh004437@cfjl.com.br","ep343237@gmail.com","anandasaletebarroslima@gmail.com","sepkaluisfelipe@gmail.com","lenacypriano@gmail.com","carolina.alvarenga@colegioprogresso.com.br","danielacanocalle@gmail.com","fischeratara@gmail.com","beatriz.ferreira.santos13@escola.pr.gov.br","emilyqdrosa@gmail.com","ana.souza@edu.colegiolondrinense.com.br","gabriellamoreirasilva34@gmail.com","scheerenheloisa@gmail.com","20000714@liberato.com.br","beberlobo@gmail.com","adajamilegomesdeoliveira.a@gmail.com","gmarrique123@gmail.com","jank@colegiojpa.com.br","marinachapuis7@gmail.com","camily.borges@estudante.ifms.edu.br","isadorapiccoli@ienh.com.br","yasmin-6539298@educar.rs.gov.br","luiza.costa@degrausnet.com.br","joiceleicia@gmail.com","vaccinecontroleureka@gmail.com","ph267708@gmail.com","ph267708@gmail.com","dmitrimendeleiev1@gmail.com","jrojasfisica@gmail.com","av@man.gov.ua","vitoria.goulart.silva@escola.pr.gov.br","naiaramarttin@gmail.com","21000312@liberato.com.br","elimbenzecry@gmail.com","Carvalhomachado1975@gmail.com","tatianernuness@gmail.com","geovana.souza195@aluno.enova.educacao.ba.gov.br","sacramentoheloisa3@gmail.com","gustavolliveira12@gmail.com","dissolucaoeco@gmail.com","emilly.epialpibicjr@gmail.com","giovannavitoria412@gmail.com","quimilabifms@gmail.com","gustavo.palhares@coree.g12.br","nicoly-silveira2@educar.rs.gov.br","gabriela.batistela@degrausnet.com.br","maia.paulo05@aluno.ifce.edu.br","laura.orselli@coree.g12.br","ricardo.c.bruschi@gmail.com","arianaesswein0804@gmail.com","rocioolmedo123665@gmail.com","arthurconceicao2005@gmail.com","marthaaklauck@gmail.com","paola.ponne@gmail.com","21000274@liberato.com.br","pedrowolski2@gmail.com","camikslv@gmail.com","20000667@liberato.com.br","20000716@liberato.com.br","vitormiguelwf@gmail.com","eduardafcaraffini@gmail.com","jisnickbw@gmail.com","machinefarroups2023@gmail.com","lilian.silva@cparaiso.com.br","fernando.gsatolo@gmail.com","joaopedrobrinhosavieira@gmail.com","ferreirinhaar@gmail.com","mostratec7@redecaminho.com.br","lailamarconatto@gmail.com","scheidtkauan8@gmail.com","gr006958@cfjl.com.br","castelviema023@gmail.com","nodelica123@gmail.com","venchkovskaa@gmail.com","leticiameirinholima@gmail.com","siafeureka@gmail.com","anaelisa.gomes@icloud.com","jonathanacederogamer@gmail.com","vinicius.nunes3@estudante.ifms.edu.br","raquel26rezende@gmail.com","21000233@liberato.com.br","02150200@aluno.canoas.ifrs.edu.br","sibellebobrzyk@outlook.com","bernardonn10@gmail.com","victorgabrieldeckmann@gmail.com","gabrielpontemello1@gmail.com","eduardadesanti19@gmail.com","gustavomartinssilva2005@gmail.com","21000171@liberato.com.br","rafaelcorrea.rs05@gmail.com","21000483@liberato.com.br","joaopedrosmaus@gmail.com","gustavokoga31@gmail.com","mostratec2024nanosatelite@gmail.com","cathepedrosso@gmail.com","surdezda@gmail.com","anabeatriz13rodrigues13@gmail.com","iesa23daniela08@gmail.com","chengyou1368@gmail.com","josephmostratec@gmail.com","jftakano@gmail.com","eurekacascavel@gmail.com","biancadaniellisimon@gmail.com","20000060@liberato.com.br","bibicadorestefani@gmail.com","milenaflores07@gmail.com","anabeatriz.tsuboi@aluno.interativalondrina.com.br","bruna.nobre@colegiodombosco.net","lucas.rasia@colegiodombosco.net","cienciavaicinema@gmail.com","alexandre.polizel@ifes.edu.br","sandrorobertojunior@gmail.com","pmaica77@gmail.com","leandro.duarte2@estudante.ifms.edu.br","fernanda.m@colegiosantanh.com.br","annaluisafreiredasilva@gmail.com","biomas221@gmail.com","2024aklein@jpsul.com.br","redij.contacto@gmail.com","sofiamuller1201@gmail.com","franca.mostratec@gmail.com","leticia.jarouche@giordanobruno.com.br","fernanda.brasil@giordanobruno.com.br","claudiasoares110699@gmail.com","maria.dias@jpsul.com.br","impulsionandotalentos24@gmail.com","isabelli.teixeira012@gmail.com","mariagobbo02@gmail.com","soldifinaza@gmail.com","luciana-dppenteado@educar.rs.gov.br","sarah-gsteichmann@educar.rs.gov.br","samuel-6660321@educar.rs.gov.br","valentina-dsgoncalves@educar.rs.gov.br","rafaela.orsi@aluno.interativalondrina.com.br","sophie.diniz@sou.escoladual.com.br","amandarostprog@gmail.com","mara.rodriguez@alefperetz.org.br","nicollassousa473@gmail.com","rossipedrohenrique15@gmail.com","gabriel.rsantos017@educar.poa.br","kamillimartins2412@gmail.com","correia@colegiojpa.com.br","gabrielly.santos@alefperetz.org.br","astroeducationeureka@gmail.com","andrews-cezar@educar.rs.gov.br","augusto.twainer@gmail.com","melneumannsilveira@gmail.com","lucasfmachado43@gmail.com","juliaposseltmuller@gmail.com","gustavohenrique.becker0@gmail.com","samuelrosler2006@gmail.com","21000107@liberato.com.br","stoffelmaicon@gmail.com","joaop3dro14@gmail.com","leticiasteinnn@gmail.com","toretimariana@gmail.com","camyla.msantos11@gmail.com","marcosalmeidanassar@gmail.com","lorenzoaandrade12@gmail.com","gigigiovanarl@gmail.com","allinealourenco@gmail.com","vascaciomedeiros@gmail.com","procrastinacao213@gmail.com","rebecagrupo2024@gmail.com","vickiuiki@gmail.com","02732@sinodaldapaz.com.br","02097@sinodaldapaz.com.br","mlsmugnaini@ucs.br","01954@sinodaldapaz.com.br","ritaja.bhattacharjee@gmail.com","meira.f@aluno.ifsp.edu.br","bianca.sales@cda.colegiodante.com.br","annyvictoryaaoliveira@gmail.com","21000210@liberato.com.br","ingridy.silva@estudante.ifms.edu.br","acolhidaemcamboriu@gmail.com","mostratec9@redecaminho.com.br","adercamillo@gmail.com","ana.l.martins@soulasalle.com.br","paula3645i@gmail.com","nata-mrdcruz@educar.rs.gov.br","ibelotto@colegiojpa.com.br","katarina.ribeiro@alefperetz.org.br","suzanajohn@gmail.com","carreterolarissa06@gmail.com","Laurafernanda07@icloud.com","lucasthuroufi@gmail.com","meriem.bzeouich@stud.enis.tn","emiliayacob123@gmail.com","eng.grazi.bueno@gmail.com","alumnos3@colegiogirasoles.edu.py","cabralyezacesiamayara@gmail.com","ana.sousa28@estudante.ifto.edu.br","augustolemosborges123@gmail.com","21000038@liberato.com.br","eduarda.vargas.2105@gmail.com","21000438@liberato.com.br","mr.thiagovargas@gmail.com","juliagabi.gomes@gmail.com","cinthias0br@gmail.com","migsiqueirapaz@gmail.com","2025asouza@jpsul.com.br","gustavo.fiegenbaum@aluno.senai.br","ernanysantosdeoliveira@gmail.com","wh0is.5uli4@gmail.com","vinicius.pavanello@aluno.ifsp.edu.br","emicubas332@gmail.com","juliamssc@gmail.com","pmatias@fjuventude.pt","carlosreciclobot@gmail.com","joao-claro@educar.rs.gov.br","1712117@aluno.cmc.com.br","estevao.nelson@gmail.com","caixatransporteorgaos@gmail.com","djeniferngrunitzky@gmail.com","327002@profe.sed.sc.gov.br","21000177@liberato.com.br","joelrodrigues@ifsul.edu.br","aliceeschroerr@gmail.com","didglabrobotica@gmail.com","biabach31@gmail.com","marqueszenivitor@gmail.com","21000353@liberato.com.br","josu.schwartz1@gmail.com","joaovgirardi@gmail.com","21000126@liberato.com.br","fonsecasantanaluisa@gmail.com","amoraesjobim@gmail.com","schmokel.laura@gmail.com","nayele.engmecanica@gmail.com","douglas.raixz@escola.pr.gov.br","ajsbarda@gmail.com","wheelonboard@gmail.com","m.andreyoliveira@gmail.com","22000114@liberato.com.br","21000096@liberato.com.br","21000321@liberato.com.br","22000528@liberato.com.br","21000160@liberato.com.br","giovannalehnenkauer@gmail.com","jujufrrz7@gmail.com","annebf2007@gmail.com","robervan.araujo@ifms.edu.br","mceciliawo@gmail.com","fernanda.ramminger@colegiosantanh.com.br","juliacosta200705@gmail.com","mtarizzotto@ucs.br","bialoula8@gmail.com","igor.pletsch@gmail.com","roboticaceccf@gmail.com","vitoriamuller2201@gmail.com","lucas.carvalho@colegiodante.com.br","antonydacosta2004@gmail.com","bell-krentkoski@educar.rs.gov.br","home.art.studio24@gmail.com","gstregansin@ucs.br","barbierigabrielvf@gmail.com","julia-silva101@educar.rs.gov.br","arturovill24@gmail.com","anajulia.feitoza70@gmail.com","victoria.gomes@aluno.feliz.ifrs.edu.br","fabrieli259@gmail.com","raul.scimeoni@escola.pr.gov.br","22000119@liberato.com.br","21000082@liberato.com.br","22000166@liberato.com.br","22000187@liberato.com.br","20000691@liberato.com.br","thaiscmoraes2005@gmail.com","kevinbortoleto18@gmail.com","sofiahaide.borgesfleck0705@gmail.com","lucas.silva2281@aluno.ce.gov.br","mariaheloisacruz05@gmail.com","2021310340@aluno.osorio.ifrs.edu.br","continivaldugalaura@gmail.com","juliaestefanidasillva@gmail.com","sandraseleri17@gmail.com","rafaela-dafagundes@educar.rs.gov.br","daniel.moura3@estudante.ifto.edu.br","ftcaliendo@ucs.br","precicla2024@gmail.com","chartanovicznatiele@gmail.com","5938.pedroguerra@gmail.com","gmiglioretto@colegiojpa.com.br","lucasavelino.mostratec@gmail.com","felipe.zlot@alefperetz.org.br","elprincipecarlitos16@gmail.com","cauegiacomelliacosta@gmail.com","marianamarques.nh026@academico.ifsul.edu.br","cassiano3241@gmail.com","mombergerluisamera@gmail.com","21000062@liberato.com.br","20000520@liberato.com.br","juyansotelo@gmail.com","vickymendoza3651@gmail.com","isadoraborges.acad@gmail.com","mateusseguro7@gmail.com","henrique.nudep@gmail.com","projetosmcr2019@gmail.com","luisgusair155@gmail.com","mostratec2024jardinsfiltrantes@gmail.com","S.julia28@escola.pr.gov.br","soraya.rodrigues1@aluno.ce.gov.br","professoracamilaarenhart@gmail.com","anaile-folle@educar.rs.gov.br","anelise@aluno.sinodaltiradentes.com.br","livia-fgrassi@educar.rs.gov.br","pedagogico.santa@nd.org.br","kaillandasilvaoliveira@gmail.com","rayssa-bsoares@educar.rs.gov.br","dhsymila@gmail.com","ezequiel.a.drehmer@gmail.com","alexandraperin.s@gmail.com","danieleschuh@ienh.com.br","isadora.franz@institutoivoti.com.br","mario-vnirala@educar.rs.gov.br","luize.bw@gmail.com","leticia@aluno.sinodaltiradentes.com.br","alumnos2@colegiogirasoles.edu.py","sotomayorsofianicol@gmail.com","moniquecdossantos@gmail.com","marianamilanipinheiro@gmail.com","giovanne19996@gmail.com","amanda.boff@lasalle.org.br","gustavo-wkich@educar.rs.gov.br","sara.brocardo@escola.pr.gov.br","shaiemedeiros@gmail.com","gmarirochag@gmail.com","eliezercagarras@gmail.com","danielladepaulabarros@gmail.com","lucasadnascimento@gmail.com","eduardaramoscorrea15@gmail.com","pamelatpiacentini@gmail.com","Bemenezes130819@gmail.com","Kaykialves1305@gmail.com","20000678@liberato.com.br","delimabastrafaela@gmail.com","cayena.sfg@gmail.com","21000278@liberato.com.br","laurenbschenkel@gmail.com","2024scampos@jpsul.com.br","Rebecalorelayne24@gmail.com","bryantheobalddasilva@gmail.com","fotos.camila.arenhart@gmail.com","padrewernermostratec@gmail.com","antoniolhuan16@gmail.com","npfabreu@gmail.com","dudaaudibert7@gmail.com","silvia-rstroeher@educar.rs.gov.br","sabine.faerge_11@yahoo.com","lauradsp03@gmail.com","caramelolucy10@gmail.com","maisamarlaposowitch@gmail.com","02522@sinodaldapaz.com.br","marialuyzafernandes05@gmail.com","giovannalongo@aluno.gaylussac.com.br","cellinalga@gmail.com","tatianetha@gmail.com","sgpoyer@ucs.br","manueladaitxzz@gmail.com","produtobaseveg@gmail.com","sofiamotaestudos@gmail.com","pablocamilo3108@gmail.com","afulbercardoso@gmail.com","jessivammorais@hotmail.com","amandaamandaoliveiraaguiar@gmail.com","domihelpereureka@gmail.com","hellensousaa2007@gmail.com","artur.schirmer@duque.g12.br","isabellimarques542@gmail.com","andressa.martins@alefperetz.org.br","henrique-schmidt@educar.rs.gov.br","vanessa-bdvargas@educar.rs.gov.br","leticia.waissmann@alefperetz.org.br","fernanda.vtrindade015@educar.poa.br","ariel.davidovici@alefperetz.org.br","daniellebrito1880@gmail.com","meduardapanizzibello@hotmail.com","dudaavila02@gmail.com","isaengster@gmail.com","mairamoureira@gmail.com","21000252@liberato.com.br","21000303@liberato.com.br","meduarda.proenca00@gmail.com","gabrieltboufleur@gmail.com","giovannaviacava3@gmail.com"
    ];

//CHECK API KEY
test_header_key();

$json = file_get_contents('php://input');
    
$json = json_decode($json,true);


if(empty($json['student_data'])){
    http_response_code(400);
    die(json_encode([
        'debug' => 'student_data'
    ],JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES));
}
$student_data = $json['student_data'];

if(isset($student_data['cpf'])){
    $cpf = mysqli_real_escape_string($conn,$student_data['cpf']);
}else{
    http_response_code(400);
    die(json_encode([
        'debug' => 'cpf'
    ],JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES));
}

if(isset($student_data['name'])){
    $name = mysqli_real_escape_string($conn,$student_data['name']);
}else{
    http_response_code(400);
    die(json_encode([
        'debug' => 'name'
    ],JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES));
}

if(isset($student_data['birth'])){
    $birth = mysqli_real_escape_string($conn,$student_data['birth']);
    $birth = str_replace('/','-',$birth);
    $birth = strtotime($birth);
    $birth = date('Y-m-d',$birth);
}else{
    http_response_code(400);
    die(json_encode([
        'debug' => 'birth'
    ],JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES));
}


if(isset($student_data['email'])){
    $email = mysqli_real_escape_string($conn,$student_data['email']);
}else{
    http_response_code(400);
    die(json_encode([
        'debug' => 'email'
    ],JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES));
}
if(isset($student_data['phone'])){
    $phone = mysqli_real_escape_string($conn,$student_data['phone']);
}else{
    http_response_code(400);
    die(json_encode([
        'debug' => 'phone'
    ],JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES));
}

if(isset($student_data['city'])){
    $city = mysqli_real_escape_string($conn,$student_data['city']);
}else{
    http_response_code(400);
    die(json_encode([
        'debug' => 'city'
    ],JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES));
}

if(isset($student_data['state'])){
    $state = mysqli_real_escape_string($conn,$student_data['state']);
}else{
    http_response_code(400);
    die(json_encode([
        'debug' => 'state'
    ],JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES));
}


if(!in_array($email,$emails)){
    http_response_code(400);
    mysqli_rollback($conn);
    mysqli_close($conn);
    die(json_encode([
        'message' => 'E-mail não autorizado para cadastro'
    ],JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES));
}


$sql_group = "SELECT id_group FROM `groups` WHERE `level` = 0 LIMIT 1";
$result_group = mysqli_query($conn,$sql_group);
if(!$result_group){
    $error = mysqli_error($conn);
    http_response_code(500);
    mysqli_rollback($conn);
    mysqli_close($conn);
    die(json_encode([
        'debug_sql' => $error,
        'debug' => 'error getting group id',
    ],JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES));
}
$row_group = mysqli_fetch_assoc($result_group);
$id_group = $row_group['id_group'];

$id_code = "null";
if(isset($student_data['code'])){
    $code = mysqli_real_escape_string($conn,$student_data['code']);
    $sql_code = "SELECT id_code FROM `codes` WHERE `label` = '{$code}' LIMIT 1";
    $result_code = mysqli_query($conn,$sql_code);

    if(!$result_code){
        $error = mysqli_error($conn);
        http_response_code(500);
        mysqli_rollback($conn);
        mysqli_close($conn);
        die(json_encode([
            'debug_sql' => $error,
            'debug' => 'error getting code id',
        ],JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES));
    }

    if(mysqli_num_rows($result_code) < 1){
        http_response_code(400);
        mysqli_rollback($conn);
        mysqli_close($conn);
        die(json_encode([
            'message' => 'O código de cadastro informado é inválido'
        ],JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES));
    }

    $row_code = mysqli_fetch_assoc($result_code);
    $id_code = '"' .$row_code['id_code'] . '"';

}

if(isset($student_data['password'])){
    $password = mysqli_real_escape_string($conn,$student_data['password']);
}else{
    http_response_code(400);
    die(json_encode([
        'debug' => 'password'
    ],JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES));
}

$sql_verify = "SELECT id_user FROM users WHERE email = '{$email}';";

$result_verify = mysqli_query($conn,$sql_verify);
if(!$result_verify){
    $error = mysqli_error($conn);
    http_response_code(500);
    mysqli_rollback($conn);
    mysqli_close($conn);
    die(json_encode([
        'debug' => 'email verify',
        'debug_error' => $error
    ],JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES));
}

if(mysqli_num_rows($result_verify) > 0){
    $error = mysqli_error($conn);
    http_response_code(400);
    mysqli_rollback($conn);
    mysqli_close($conn);
    die(json_encode([
        'message' => 'O endereço de e-mail já está em uso.'
    ],JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES));
}

$sql_create = "CALL sp_create_user('37e44344-f0c5-11ec-a869-00e04c0362fc','{$id_group}',0,'{$cpf}','{$name}','{$email}','{$phone}', md5('{$password}'),'{$city}','{$state}',{$id_code},'{$birth}',1)";

$result_create = mysqli_query($conn,$sql_create);

if(!$result_create){
    $error = mysqli_error($conn);
    http_response_code(500);
    mysqli_rollback($conn);
    mysqli_close($conn);
    die(json_encode([
        'debug' => $error,
        'debug_sql' => $sql_create
    ],JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES));
}

send_register_email($conn,$url_alt,$password,$name,$email);

http_response_code(200);
mysqli_commit($conn);
mysqli_close($conn);

die();

?>

